﻿/* Generated with Author-it 5.5.264.13693  1/28/2016 11:38:28 AM */
Page=new Array();Page[0]=new Array("Purpose","This document addresses the basic needs of the following groups:","Plesk administrators who wish to automate routine operations. In this document, they will find alternatives to the GUI-based approach in Plesk management. ","Integrators who build their application into Plesk or set up interactions between Plesk and third-party software. In this document, they will learn how to manipulate Plesk objects and views, and handle Plesk events.","Scope","This document is an overview of all the available interfaces Plesk reveals to third parties. It explains which technologies to use to carry out all types of typical interaction tasks (such as creation of objects, handling events, building your own controls into the GUI, etc.). From this document, you will learn conceptual details about each integration interface, see examples of them in use, and receive references to documents that contain more specific details.","We would like readers to consider this document as a starting point in using Plesk integration capabilities. The document does not provide extensive details, complex case studies, and working code samples. For such information, refer to the interface-specific documentation:","Command Line Reference for Linux","Command Line Reference for Microsoft Windows","XML API Manual","Plesk Extensions Reference","About This Document","about.htm");
Page[1]=new Array("When managing Plesk using any interface or technology described in this document, you may need to know the structure and the objects of the Plesk database. Therefore, studying the database scheme can be useful.","The files of the Plesk database scheme can be found here: https://github.com/plesk/db-schemas. The following files are provided:","psadb.mvb - the project file that can be opened in the MySQL Workbench unified visual tool. This free tool allows you to visualize and study databases and, additionally, can be used for other purposes such as database design and modeling, SQL development, database administration, and so on. Using this format can be recommended as the most user-friendly and convenient way to view and study the Plesk database scheme.","psadb.svg - the file in the SVG (Scalable Vector Graphics) image format that can be opened in a web browser to view an image of the Plesk database scheme. ","psadb.xml - the XML scheme of the Plesk database. ","Plesk Database Scheme","75240.htm");
Page[2]=new Array("This chapter provides a bird's eye view of Plesk integration capabilities. Using these, you can control Plesk objects, react to Plesk events, make your applications available to Plesk users, and build own GUI into Plesk. In this chapter, we will briefly mention each of the integration capabilities and give our recommendations on when to use them. ","Performing Create, Read, Update, Delete (CRUD) Operations on Plesk Objects","A typical integration task is to manage Plesk objects (service plans, customer accounts, and so on) more quickly, bypassing the Plesk GUI. This task is relevant to administrators who manage a number of Plesk servers and wish to automate day-to-day operations. It is also important for integrators who need to set up relations between objects in Plesk and their application. There are two ways to complete the task:","Make an appropriate Command Line Interface (CLI) call.","Make an appropriate XML API call.","&nbsp;&nbsp;&nbsp;","CRUD operations from CLI","CLI is a set of utilities that perform almost all operations on Plesk objects from the command line. A popular use of this interface is to replace typical GUI operations with utility calls, create shell scripts, and run them on demand. To call one of the utilities, you should have administrative permissions on Plesk server. ","&nbsp;","Each CLI utility specializes in operations on a certain Plesk object (for example, a customer account) and has a specific syntax. You can learn about the syntax either from the built-in help or from the corresponding documentation. ","Learn more about how to get started using CLI in the chapter Command-Line Interface (CLI).","For complete information about CLI, refer to Plesk 12.5 Command Line Reference (Windows) and Plesk 12.5 Command Line Reference (Linux).","&nbsp;","The major limitation of CLI is that you can only use it from a local server and only on behalf of the administrator. Alternatively, use the XML API protocol if you require more flexibility, for example: ","Work with a remote Plesk server.","Manage objects located on several Plesk servers at the same time.","Run operations on behalf of a reseller or a customer.","&nbsp;&nbsp;&nbsp;","CRUD operations from XML API","The XML API protocol allows you to manipulate Plesk objects by exchanging XML-structured packets with Plesk. Each operation in XML API is presented as an XML structure that you send to a certain HTTP endpoint. Plesk receives the operation request, processes it, and also responds with an XML-structured packet. Each such response includes an operation status and operation-related details. For example, if you request information about a customer account, the account details will be returned in XML.","&nbsp;","An operation request packet also includes information about a Plesk user on behalf of whom the operation is performed. This lets you automate the routines of any Plesk user.","&nbsp;&nbsp;","Every operation available through CLI is also available through XML API. This makes XML API a more powerful tool, though the protocol implementation assumes programming efforts on your part (you should write a client application that sends and receives XML-over-HTTP packets). ","Learn more about how to get started using XML API in the XML API Protocol chapter.","For complete information about XML API, refer to XML API Manual.","Monitoring Plesk Events by Using Event Handlers","Another typical integration task is to react to a particular operation on a Plesk object. Examples of when such a reaction is important are as follows:","Keep the app and Plesk objects synced.","For example, if your application needs to have the same list of customer accounts as Plesk does, you should track the creation of customer accounts and create a new account every time Plesk creates one. ","Generate custom statistics and notifications.","For instance, one may need to receive an email each time a service utilized by Plesk is stopped. ","To track Plesk operations and react correspondingly, employ event handlers.","&nbsp;","An event handler is a link between a particular operation and an instruction: When Plesk completes the operation, it runs the linked instruction. The operation list is vast, so you can control almost all business logic operations. The instruction to trigger is usually a script or a binary. Depending on the operation, the instruction receives environmental variables that contain information about an operation target (Plesk object) &quot;before&quot; and &quot;after&quot; the operation. For example, the environment variables keep &quot;old&quot; and &quot;new&quot; customer account names in case the account name was changed.","Learn more about how to get started using event handlers in the Event Handlers chapter. ","For complete information about event handlers, refer to the Administrator&#8217;s Guide, chapter Event Tracking.","Receiving Notifications About Changes in Subscriptions, Sites, and Email Accounts with Plesk Notifications","The other way for you to integrate an application into Plesk is to register it as an additional service. Such services are assigned to service plans and receive notifications about changes to plans instances - subscriptions and related objects (sites and email accounts). Registration is advisable only if you want to track these changes. For example, mail processing software should register in Plesk Notifications to track changes in the email account names of subscribers. In other words, Plesk Notifications is an extension of the event handler mechanism.","Learn more in Plesk Notifications.","Deliver Your Application as APS Package","When a web application is ready to market, the most convenient way for vendors to distribute the app is by adding it to the APS Catalog. The catalog is a part of Control Panel where customers can find an application and install it to their website. This ability to present third-party software in Plesk might be interesting to integrators especially if their application uses Plesk resources and has peculiarities in deployment and maintenance.","APS - Application Packaging Standard - is a set of rules that regulates web application installation, updates, licensing, and removal. If you make your application APS-compatible, you will not need to worry about application delivery because Plesk will carry out all the installation and maintenance operations for you.","Learn more about how to get started with APS packaging in the APS Packages chapter. ","For complete information about APS packaging, refer to http://doc.apsstandard.org/_downloads/package-format-specification-12.pdf.","Build Your App into the Plesk GUI","Earlier versions of Plesk provided the mechanism of extending its base functionality with plug-ins called extensions (former modules). These plug-ins could access Plesk resources and have custom pages inside the Plesk GUI. The earlier versions of SDK and the corresponding documents are incompatible with Plesk 12.5, and for this reason, we recommend that you refer to the Developing Extensions for Plesk.","For information about developing extensions for Customer and Business Manager, refer to the Customer and Business Manager SDK.","Plesk Database Scheme","To manage Plesk objects with one of the described methods, you need to know the structure of the Plesk database objects. The Plesk database scheme is provided below in the three formats:","MWB - the format of a project that can be opened in MySWL Workbench 6.3 unified visual tool. This free tools allows you to visualize and study the database, and additionaly","SVG - vector format.","XML - xml format.","Integration and Automation Capabilities","68662.htm");
Page[3]=new Array("The Command-Line Interface (CLI) is a set of command-line utilities that enable administrators to manage Plesk server configuration, reseller and customer accounts, websites, and various services. The utilities can also be used for integration with third-party software.","&nbsp;","By default, the utilities are located in the following server directories:","(On Linux servers) /usr/local/psa/bin","(On Windows servers) C:\\Program Files\\Parallels\\Plesk\\bin","Note: For convenience, the CLI directory is defined by the Windows environment variable %plesk_cli%. You can use it as an alternative to the absolute path.","&nbsp;","Each utility has its own application scope. For example, the dns utility is responsible for DNS zones, while the database utility lets you manage databases and DB user accounts. The functions carried out by utilities are reflected in their syntax. ","For example, this call creates a customer account with the john username and the mypass password in a Linux server.","/usr/local/psa/bin/customer --create john -passwd mypass","To find what operations and options each utility provides, call the utility with the --help option or find more details in the CLI documentation. Complete information about CLI is available in two separate documents, for Windows and for Linux operating systems. The documents are called Plesk 12.5 Command Line Reference (Windows) and Plesk 12.5 Command Line Reference (Linux) respectively.","Command-Line Interface (CLI)","68674.htm");
Page[4]=new Array("Plesk provides the XML-based API to support interaction with third-party software. This interface lets you manage Plesk objects - subscriptions, service plans, customer accounts, and so on. The interface is designed as a means of calling Plesk operations remotely. This ability is reflected in its name - XML API - Application Programming Interface for Remote Procedure Calls. ","How to work with XML API","To perform an operation through XML API, you should send a specifically-structured HTTP message to a particular Plesk endpoint (https://&lt;your-host-or-IP&gt;:8443/enterprise/control/agent.php). Plesk receives the message, transforms the message to the operation instruction, attempts to perform the operation, and returns the operation status and details. ","An arbitrary HTTP message, a unit of interaction between third-party software and XML API, can be represented graphically in the following way:","When forming the message, you should include Plesk user credentials as specific HTTP headers and insert an XML presentation of the operation into the HTTP body. The format of  such XML presentations and the format of the XML-like responses from Plesk are covered by the XML API protocol.","From Theory to Practice","In practical terms, to perform an operation through XML API, you should do the following:","Create an XML presentation of the operation","Add the XML code to the body of an HTTP message","Add Plesk user credentials to the message header (HTTP_AUTH_LOGIN and HTTP_AUTH_PASSWD)","Send this HTTP message to the Plesk endpoint.","Below, we provide more details on each of the steps.  &nbsp;","Create an operation description.","Construct the XML presentation using the Reference chapter of the latest version of the XML API Manual.","For example, if you wish to add a reseller plan, you should have an XML structure similar to this one:","&lt;packet version=&quot;1.6.3.0&quot;&gt;","&lt;reseller-plan&gt;","&lt;add&gt;","   &lt;name&gt;sample_plan&lt;/name&gt;","   &lt;ip-pool&gt;","      &lt;allocate-ip&gt;2&lt;/allocate-ip&gt;","   &lt;/ip-pool&gt;","&lt;/add&gt;","&lt;/reseller-plan&gt;","&lt;/packet&gt;<br>","Form an HTTP message and send it to Plesk. ","There are a variety of libraries that let you easily create and send HTTP messages with custom headers and body. Depending on the programming language you use, utilize cURL, HttpWebRequest, or other libraries. <br>","Parse and analyze the Plesk response.","Plesk responds to each XML API request packet with a response packet that contains an operation status and details. For the details on structures Plesk returns for each operation, consult the Reference chapter as well. If the operation status is OK, you have successfully performed the remote operation.","Further details and instructions related to XML API are available in the XML API Manual. As we mentioned earlier, the document contains the explanation of the protocol, client software samples, and XML presentations of all operations supported by Plesk through XML API.","XML API Protocol","68677.htm");
Page[5]=new Array("Event handlers are designed to help you receive notifications about Plesk events. The most typical way to use them is as follows: you create a script to be executed upon a certain Plesk event, and then you associate the event and your script using an event handler. Each time the event happens, the event handler will trigger your script.","The instruction to run is not necessarily a script. You can also associate event handlers with a system command or a binary file. In addition, there are two facts to consider before you start using event handlers:","Event handlers trigger instructions on behalf of the Plesk administrator.","Event handlers have information about a related Plesk object &quot;before&quot; and &quot;after&quot; an event.","When an event occurs, event handlers receive the event details, and you can use these details in your instructions. For example, you can obtain the IP address which was added by the &quot;adding an IP address&quot; event. The event details are passed to your instructions as environment variables.","Note: We strongly recommend that you enter a full path to a script file as a command to event handlers. Although you can assign direct system commands, they might not work. Say, commands with output redirection operators &gt;, &lt;, &gt;&gt;, or | will not work.","Running scripts via event handlers","For example, let's store the names of new customers on the file system. To do this, first we should find the environment variable that contains the contact name. This variable is listed in the Administrator's Guide, Appendix &gt; Customer account created.","As you can see, the variable name is NEW_CONTACT_NAME. Now we need to create an event handler.","To create the event handler on Linux:","Create a shell script (for example, write-names.sh) containing the following code:","#!/bin/bash","echo &quot;Customer account has been created. Name: ${NEW_CONTACT_NAME}&quot; &gt;&gt; /tmp/event_handler.log","Log in to Plesk, go to the Tools &amp; Settings tab &gt; Event Manager.","Click Add New Event Handler and specify the following:","Event. Select Customer Account Created from the menu.","Priority. Leave set to lowest (0).","User. Leave set to root.","Command. Specify the path to the shell script created during step one (for example, /tmp/write-names.sh).","Click OK.","To create the event handler on Windows:","Create a batch file (for example, write-names.bat) containing the following code:","echo &quot;Customer account has been created. Name: %1&quot; &gt;&gt; C:\\Windows\\Temp\\event_handler.log","Log in to Plesk, go to the Tools &amp; Settings tab &gt; Event Manager.","Click Add New Event Handler and specify the following:","Event. Select Customer Account Created from the menu.","Priority. Leave set to lowest (0).","User. Leave set to Plesk Administrator.","Command. Specify the path to the shell script created during step one (for example, C:\\Windows\\Temp\\write-names.bat) and specify the variable name (as we discovered above, it is new_contact_name) in angle brackets. The result should look like this:","C:\\Windows\\Temp\\write-names.bat &lt;new_contact_name&gt;","Click OK.","The event handler will be triggered every time a new customer account is created, and will write the customer&#8217;s contact name to the specified file.","For more details on event handlers, refer to the Administrator's Guide, the chapter Event Tracking. This chapter provides instructions on how to create event handlers and describes environment variables related to each Plesk event.","Event Handlers","68703.htm");
Page[6]=new Array("In the Plesk hosting model, you can ship service plans with third-party services. These services are called additional services. For example, if you have a service that performs custom mail filtering, Plesk lets you offer this service with, say, the Silver hosting plan, while it is not offered with others.","&nbsp;","Some additional services require information about instances of service plans - subscriptions and dependent objects (sites, email accounts). If your service needs information about changes in these objects, register it in the Plesk Notifications service (PN).","Note: Events that PN maintains are beyond the scope of event handlers.","PN works in a similar way to event handlers: You register your service as a PHP class, and Plesk runs appropriate methods of this class when one of the events (maintained by the service) happens. The service maintains the following objects and actions upon them.","Objects: subscription, site, email account.","Actions: create, modify, remove.","After each action, PN offers these details about current object properties.","Object","Details","subscription","status, GUID","site","status, name, GUID","email account","email address","Note: If you need further details about these objects, use an appropriate XML API or CLI call to receive them.","How to get started using PN","To prepare a service for registration with PN, you should implement the appropriate PHP interface run an appropriate Plesk call. The details of these operations are too technical to describe in this overview guide. To learn more about PN and service registration, refer to the Advanced Administration Guide for Plesk for Linux.","Plesk Notifications","68706.htm");
Page[7]=new Array("Suppose you have a web application and would like to know how to deliver it to Plesk customers. The best way would be to put the app into the APS Catalog. For this, you should create an APS package from your app and have it certified for the APS Catalog.","About creation of APS packages","Creating an APS package, in technical terms, is the same as creating a ZIP archive that contains the content of your app and metadata. Plesk uses this metadata to install and manage instances of the app. The metadata consists of the following: ","Application requirements  - the technologies that the app will use; for example, PHP 5.3, Apache, MS SQL database, etc., and the way to use them (such as permissions to read or write to a particular directory).","Application settings that a customer or the administrator can specify upon installation and configuration.","Deployment and maintenance scripts that are invoked during application service provisioning, canceling, updating and reconfiguration.","Miscellaneous information for proper presentation in Plesk (such as the license agreement, icon, description, screen shots, category, etc.)","When designing app metadata, you only need to specify the required information, so it should not take much time to prepare an APS package from a typical web app. ","For guidelines on how to prepare APS packages, refer to http://doc.apsstandard.org/_downloads/package-format-specification-12.pdf.","How to succeed in APS certification","Once you have prepared a package, the application must pass the certification procedure to appear in the APS Catalog. Obtaining certification requires these steps to be completed:","Test your APS package with an APS-compliant product.","Get access credentials to the APS Certification System.","Upload the APS package for certification procedure.","Resolve APS package issues if any have been found during certification.","After receiving a certification level and passing all tests, request publication of the application.","For more information about certification, refer to http://doc.apsstandard.org/cert/.","APS Packages","68710.htm");
var PageCount=8;

function search(SearchWord){
var Result="";
var NrRes=0;
Result='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">\n';
Result+="<html>\n";
Result+="<head>\n";
Result+="<title>Search Results</title>\n";
Result+="<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>\n";
Result+='<script language="javascript" type="text/javascript" charset="UTF-8" src="dhtml_search.js"></script>\n';
Result+='<link rel="stylesheet" type="text/css" href="stylesheet.css">\n';
Result+="</head>\n";
Result+="<body onload='javascript:document.SearchForm.SearchText.focus()'>\n";


/* old */ /*

Result+='<p class="searchDetails">Enter a keyword or phrase';

Result+='<form name="SearchForm" action="javascript:search(document.SearchForm.SearchText.value)">';
if(SearchWord.length>=1){
   while(SearchWord.indexOf("<")>-1 || SearchWord.indexOf(">")>-1 || SearchWord.indexOf('"')>-1){
       SearchWord=SearchWord.replace("<","&lt;").replace(">","&gt;").replace('"',"&quot;");
   }
}
Result+='<input type="text" name="SearchText" size="25" value="' + SearchWord + '" />';
Result+='&nbsp;<input type="submit" value="&nbsp;go&nbsp;"/></form>';
Result+='</p>\n';

*/ /* new */


Result+='<form name="SearchForm" action="javascript:search(document.SearchForm.SearchText.value)">';
Result+='<p class="searchDetails">Enter a keyword or phrase';

if(SearchWord.length>=1){
   while(SearchWord.indexOf("<")>-1 || SearchWord.indexOf(">")>-1 || SearchWord.indexOf('"')>-1){
       SearchWord=SearchWord.replace("<","&lt;").replace(">","&gt;").replace('"',"&quot;");
   }
}

Result+='<input type="text" name="SearchText" class="inputText" value="' + SearchWord + '" />';
Result+='&nbsp;<input type="submit" value="&nbsp;go&nbsp;"/>';
Result+='</p>\n';
Result+='</form>\n';

/* end */



if(SearchWord.length>=1){
   SearchWord=SearchWord.toLowerCase();
   this.status="Searching, please wait...";
   Result+="<table border='0' cellpadding='0' cellspacing='0' class='tocTable' width='90%'>";

   for(j=0;j<PageCount;j++){
       k=Page[j].length-1;
       for(i=0;i<k;i++){
           WordPos=Page[j][i].toLowerCase().indexOf(SearchWord);
           if(WordPos>-1){
                NrRes++;
               break; }}}

   Result+="<tr><td class='search'><p class='searchFound'>" + NrRes + " results found</p></td></tr>";

   for(j=0;j<PageCount;j++){
       k=Page[j].length-1;
       for(i=0;i<k;i++){
           WordPos=Page[j][i].toLowerCase().indexOf(SearchWord);
           if(WordPos>-1){

               FoundWord=Page[j][i].substr(WordPos,SearchWord.length);
               NrRes++;
               Result+="<tr><td class='search'><p class='searchResults'>";
               Result+="<a target='BODY' href='"+Page[j][k]+"'>"+Page[j][k-1].replace(FoundWord,"<span class='searchFoundWord'>"+FoundWord+"</span>")+"</a><br/>\n";

               if(i<k-1){
                   if(Page[j][i].length>350){
                       Result+="..."+Page[j][i].substr(WordPos-100,200+FoundWord.length).replace(FoundWord,"<span class='searchFoundWord'>"+FoundWord+"</span>")+"...\n";
                   }
                   else{
                       Result+=Page[j][i].replace(FoundWord,"<span class='searchFoundWord'>"+FoundWord+"</span>")+"\n";
                   }
               }
               Result+="</p></td></tr>";
               break;			   
           }		   
       }	   
   }
     
   Result+="</table>";
   

}

Result+="</body></html>";
this.status="";
this.document.open();
this.document.write(Result);
this.document.close();
}//